package WebService::dSS::Role::NameableTest;
use base qw(WebService::dSS::TestBase);

use strict;
use warnings;

use Carp;
use Test::More;
use Test::Exception;

use WebService::dSS;
use WebService::dSS::Role::Nameable;

sub get_set_name_test : Test(3) {
	my ($self) = @_;

	my $o = NameableTestPackage->new({
		api => WebService::dSS->new({
			url => $self->get_base_url(0),
		}),
	});

	is($o->get_name(), 'some name', 'got name');
	lives_ok(sub { $o->set_name('bar') } , 'name set');
	is($o->get_name(), 'bar', 'updated name');
}


package NameableTestPackage;

use strict;
use warnings;

use Moose;
use MooseX::FollowPBP;

has 'api' => (
	is       => 'ro',
	isa      => 'WebService::dSS',
	required => 1,
);

with 'WebService::dSS::Role::Nameable';

sub get_name_base_params {
	return {
		read => {
			param  => {
				id => 0,
			},
			method => 'foo.getName'
		},
		write => {
			param  => {
				id => 0,
			},
			method => 'foo.setName'
		}
	};
}

1;
