package WebService::dSS::Role::NamedTest;
use base qw(WebService::dSS::TestBase);

use strict;
use warnings;

use Carp;
use Test::More;
use Test::Exception;

use WebService::dSS;
use WebService::dSS::Role::Named;


sub get_name_test : Test(3) {
	my ($self) = @_;

	my $api = WebService::dSS->new({
		url => $self->get_base_url(0),
	});

	my $o = NamedTestPackage->new({
		api => $api,
	});
	is($o->get_name(), 'some name', 'got name');

	# Check with callback
	$o = NamedTestPackage2->new({
		api => $api,
	});
	is($o->get_name(), 'something', 'got name');

	$o = NamedTestPackage2->new({
		api  => $api,
		name => 'my name'
	});
	is($o->get_name(), 'my name', 'got name');
}


package NamedTestPackage;

use strict;
use warnings;

use Moose;
use MooseX::FollowPBP;

has 'api' => (
	is       => 'ro',
	isa      => 'WebService::dSS',
	required => 1,
);

with 'WebService::dSS::Role::Named';

sub get_name_base_params {
	return {
		read => {
			param  => {
				id => 0,
			},
			method => 'foo.getName'
		},
	};
}


package NamedTestPackage2;

use strict;
use warnings;

use Moose;
use MooseX::FollowPBP;

has 'api' => (
	is       => 'ro',
	isa      => 'WebService::dSS',
	required => 1,
);

with 'WebService::dSS::Role::Named';

sub get_name_base_params {
	return {
		read => {
			param    => {
				id => 0,
			},
			method   => 'foo.getName',
			callback => sub {
				return 'something';
			},
		},
	};
}


1;
