package WebService::dSS::Role::SwitchableTest;
use base qw(WebService::dSS::TestBase);

use strict;
use warnings;

use Carp;
use Test::More;
use Test::Exception;

use WebService::dSS;
use WebService::dSS::Role::Switchable;


sub turn_on_off_test : Test(2) {
	my ($self) = @_;

	my $o = SwitchableTestPackage->new({
		api => WebService::dSS->new({
			url => $self->get_base_url(0),
		}),
	});

	lives_ok(sub { $o->turn_on() },  'turned on');
	lives_ok(sub { $o->turn_off() }, 'turned off');
}


package SwitchableTestPackage;

use strict;
use warnings;

use Moose;
use MooseX::FollowPBP;

has 'api' => (
	is       => 'ro',
	isa      => 'WebService::dSS',
	required => 1,
);

with 'WebService::dSS::Role::Switchable';

sub get_switch_base_params {
	return {
		on => {
			param  => {
				id => 1,
			},
			method => 'foo.turnOn'
		},
		off => {
			param  => {
				id => 1,
			},
			method => 'foo.turnOff'
		}
	};
}

1;


1;
